﻿using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace UpDown_keys
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DoubleTextBox textbox;
        RepeatButton PART_Up, PART_Down;
        double? value = 0.0;
        bool keypressed = false;

        public MainWindow()
        {
            InitializeComponent();
        }

        void upDown_Loaded(object sender, RoutedEventArgs e)
        {
            textbox = upDown.Template.FindName("DoubleTextBox", upDown) as DoubleTextBox;
            PART_Up = upDown.Template.FindName("upbutton", upDown) as RepeatButton;
            PART_Down = upDown.Template.FindName("downbutton", upDown) as RepeatButton;
            if(PART_Up!=null)
                PART_Up.PreviewMouseDown += PART_Up_PreviewMouseDown;
            if (PART_Down != null)
                PART_Down.PreviewMouseDown += PART_Up_PreviewMouseDown;
        }

        void PART_Up_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            UpdateStepValue();
        }

        private void upDown_KeyDown(object sender, KeyEventArgs e)
        {
            UpdateStepValue();
        }

        private void UpdateStepValue()
        {

            int caretindex = textbox.SelectionStart;


            switch (caretindex)
            {
                case 0:
                    upDown.Step = 1.0;
                    break;
                case 1:
                    upDown.Step = 1.0;
                    break;
                case 2:
                    upDown.Step = 0.1;
                    break;
                case 3:
                    upDown.Step = 0.01;
                    break;
                case 4:
                    upDown.Step = 0.01;
                    break;
                default:
                    upDown.Step = 1.0;
                    break;
            }


        }

   
        private void doubletextbox_PreviewKeyUp(object sender, KeyEventArgs e)
        {

            int doubletext = doubletextbox.CaretIndex;
            if (e.Key == Key.Up || e.Key == Key.Down)
            {
                keypressed = true;
                UpdateDoubleTextboxStepValue();
                e.Handled = true;
            }
            doubletextbox.CaretIndex = doubletext;
        }
        
        private void doubletextbox_ValueChanging(object sender, ValueChangingEventArgs e)
        {
            if (keypressed)
            {
                e.Cancel = true;
            }
            keypressed = false;
        }

        private void UpdateDoubleTextboxStepValue()
        {
            int length = doubletextbox.Text.Length-1;
            int separatorindex = doubletextbox.Text.IndexOf(doubletextbox.NumberDecimalSeparator);
            string[] values = doubletextbox.Text.Split('.');
            int sec_part = values[1].Length;

            double first_partlen = length - sec_part;

            int caretindex = doubletextbox.SelectionStart;            
            doubletextbox.Step = 1.0;
            doubletextbox.Value -= doubletextbox.Step;

            if (first_partlen <= 3)
            {
                switch (caretindex)
                {
                    case 0:
                        doubletextbox.Step = 100.0;
                        break;
                    case 1:
                        doubletextbox.Step = 010.0;
                        break;
                    case 2:
                        doubletextbox.Step = 001.0;
                        break;
                    case 3:
                        doubletextbox.Step = 0.01;
                        break;
                    case 4:
                        doubletextbox.Step = 0.10;
                        break;
                    case 5:
                        doubletextbox.Step = 0.01;
                        break;
                    default:
                        doubletextbox.Step = 1.0;
                        break;
                }

                doubletextbox.Value += doubletextbox.Step;
            }
           
        }

     }
}
